# wtf.uafs.tcl

# General info:
# version 1.0
# works with wtf from bsdgames package & shows acronyms meanings
# allows to dynamicly set channels where script should work on using
# command ".chanset #chan +wtf" in the partyline
# Author: CoolCold <coolcold at coolcold.org>
# #rea@irc.coolcold.org:6667
#
#
#  __    __  __    _           _    
# \  \  /  /|  \  | |         | |   
#  \  \/  / |   \ | |  ____  _| |_  
#   \    /  | |\ \| | /  _ \|_   _| 
#   /    \  | | \   | | /_\/  | |   
#  /  /\  \ | |  \  | | \__   | |__ 
# /__/  \__\|_|   \_| \____/  \___/ 
#
# http://xnet.net.ru irc://xnet.net.ru
#
#
# with help of
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
# Created with FAR ( http://www.farmanager.com )
# and colorer ( http://colorer.sf.net )
#
#
# Requirements:
# eggdrop (windrop) 1.6.15,tcl 8.4.5 (8.3.4)
# requiers uafs.tcl to enable antiflood protection

# Usage: to enable using wtf tool on channel use
# .chanset #chan +wtf inn the partyline

namespace eval wtf {
	
	#configuration section

	set wtfpath "/usr/games/wtf"
	
	#users who is allowed to use command
	set accessflags "f|f"
	
	#users who will by bypassed from flood check
	set nolimitflags "f|f"
	
	#command which calls the script
	set trigger "wtf"
	
	#setting usage limit for 3 times in 10 seconds
	set floodlimit "3:10"

	#setting ban time in minutes
	set bantime "120"

   	#end of configuration

   	##############################
   	# do not edit anything below #
    ##############################

    putlog "Loading wtf.uafs.tcl..."	
    setudef flag wtf
    
    ############################
    #do not edit anything below
    ############################

    set ufh "-1"

	proc putlog { text } {
		if {$text!=""} {
			::putlog "--- wtf: $text"
		}
	}

    #㤠塞  bind'
    putlog "Removing our old binds ( if any ) ..."
    set tbinds [llength [binds "[namespace current]::*"]]
    foreach bind [binds "[namespace current]::*"] {
        catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
    }
    putlog "$tbinds old binds removed"
   
	set ver "1.0"
	set author {CoolCold <coolcold at xnet.net.ru>}
	set infoline "wtf.tcl version $ver by $author"
    

    #஢塞 - 㦥  uafs,㥬 ⥬  tcl ந
    #"" ࠢ -    ஢  ࠦ,  .
    #⠪ ࠧ, ᫨ ६ ::uafs::numver  , ஢ઠ
    # 祭  㤥 ந.
    if {[info exists "::uafs::numver"] && $::uafs::numver>="000006"} {
            #㦥,ॣ㥬  handler
            # ࠬࠬ -  ࠭祭  floodlimit
            #⨯ ⬠᪨ - #masks(host) - ᪠  *!*@hostname
            #஢ 짮⥫  䫠  $ignoreflags
            set ufh [::uafs::registerhandle $floodlimit $::uafs::masks(host) $nolimitflags]
            if {$ufh>0} {
                    #ॣ 諠 ᯥ譮, 
                    bind pub $accessflags "$trigger" [namespace current]::trigger
            } else {
                    # 砥 訡 뢮 ᮮ饭     訡  ᠭ
                    putlog "registerhandle failed. error code \"$ufh\",error info: \"[::uafs::formatmessage $ufh]\""
            }
            
    } else {
            putlog "--------------------------------------------------"
            putlog "| No UAFS.tcl installed or too old version found |"
            putlog "| Install UAFS.tcl first and load it before      |"
            putlog "| loading this script!                           |"
            putlog "| Download latest version of uafs here:          |"
            putlog "|     http://web.coolcold.org/scripts/uafs/      |"
            putlog "--------------------------------------------------"
            putlog "$infoline version $ver by $author load failed"
            #室  楤
            return 0
    }


    proc trigger { nick uhost hand chan rest } {
        variable ufh;variable wtfpath;variable bantime
        global lastbind botnet-nick
        #஢塞, ⮨  䫠 +wtf  ...
        if {![channel get $chan wtf]} {return 0}

        # ஢  
        set flooded [::uafs::isflood $ufh $nick $uhost $chan]
        if {$flooded=="1"} {
        	;#just ignore,simply ignore
        	;#waiting for upgrade for uafs beta 5 ;)
        	set counter [::uafs::checksoftcounter $ufh $nick $uhost $chan]
        	#putlog "counter is $counter"
        	if {$counter<0} {
        		#some error occured
        		putlog "error while getting counter value, error code \"$counter\", description:[::uafs::formatmessage $counter]"
        		return 0
        	} elseif {$counter > 0} {
        		switch  -exact -- $counter {
        			"1" {
        				#1st time - warning
        				putserv "NOTICE $nick : Your flooder $nick, calm down and wait for [duration [::uafs::peacetime $ufh $nick $uhost $chan]]"

        			}
        			"2" {
        				#2nd time - kicking
         				#     堫䮯?
         				if {[botisop $chan] || [botishalfop $chan]} {
         					#ࠧ , .
         					putserv "kick $chan $nick :Stop flooding me with \"$lastbind\""
         				}

        			}
        			default {
        				#3rd & other times banning
        				set mask [::uafs::createmask $nick $uhost [::uafs::gethandleinfo $ufh "hostmask"]]
        				newchanban $chan $mask ${botnet-nick} "flooded me with \"$lastbind\"" $bantime
        			}
        		}
        	}
        	return 0
        } elseif { $flooded == "0" } {
           set errinfo ""
           if {$rest==""} {putserv "NOTICE $nick :Empty command, please specify smth";return 0}
           if {[catch {set paupau [exec -- "$wtfpath $rest"]} errinfo]} {
        		putserv "NOTICE $nick :Error occured while executing wtf tool"
        		foreach i [split $errinfo \r\n] {
        			putserv "NOTICE $nick :$i"
           		}
           } else {
           		set blabla [split $paupau \r\n]
           		foreach {i} $blabla {
        			putserv "PRIVMSG $chan :$i"
           		}
        	}
        
        }
    return 0
    }

    if {$ufh<0} {
    	putlog "$infoline version $ver by $author loaded,but some errors found"
    } else {
    	putlog "$infoline version $ver by $author loaded"
    }

}

