# UAFS for Eggdrop ( Universal Anti-Flood Script for Eggdrop )
# version: beta 10
#
# see readme.htm for full russian description

# Author: CoolCold <coolcold at coolcold.org>
# #rea@irc.coolcold.org:6667
#
#
#  __    __  __    _           _    
# \  \  /  /|  \  | |         | |   
#  \  \/  / |   \ | |  ____  _| |_  
#   \    /  | |\ \| | /  _ \|_   _| 
#   /    \  | | \   | | /_\/  | |   
#  /  /\  \ | |  \  | | \__   | |__ 
# /__/  \__\|_|   \_| \____/  \___/ 
#
# http://xnet.net.ru irc://xnet.net.ru
#
#
# with help of
#
#       :::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
# Created with FAR ( http://www.farmanager.com )
# and colorer ( http://colorer.sf.net )
#
#
# Requirements:
# eggdrop (windrop) 1.6.15,tcl 8.3.x (8.4.x)


# beta 5 changes:
# +handle info proc
# +some statistics of handle usage - hits/floods/soft&hard floods counters
# +partyline cmd to display this stats
# +possible error fixed while registering handle
# TODO:
# info proc for easy stats access
# (dunno how it should work/look & feel and if it is needed or not)
# looks like it isn't need, so skipping, going beta 6

# beta 6
# debug levels

# beta 7
# fixed error with soft/hard counters
# added mask type "all" - *!*@*

# beta 8
# TODO: add command to change debug on/off and debug level at runtime
# status:DONE
# some optimizations in isflood - let's first check for matchattr, then create mask
# changed dcc help system - no if u specify wrong/empty param, it displays help
# but not just telling u use .uafs blabla help to obtain help :)

# it looks like there are some problems with statistics, but need heavy testing

# beta 9
# added dcc bind to change events:duration for handles 
# pubstats for channels like:
# !uafs  - reports for #chan : total requests, ignored requests, masks count... 
# added comment field ( namespace name if param is missed ) 
# uafs beta 9 changelog:
# fixed some errors with stats arrays ( were not freed in unregisterhandle )

# beta 10
# added new function - ::uafs::reset - resets timestamps for selected ufh & mask
# if nick is empty, clears all timestamps list for this handle
#
# new mask type added - masks(ident) - creates mask like *!ident@*

package require Tcl 8.3
package require eggdrop 1.6
#package provide uafs 0.1

namespace eval uafs {

    set checkforcallback "1"
    
    #set to 1 to enable debug logging,0 to disable
    #you can change this from partyline, read .uafs command help
    set debugmode "1"
    
    #set debug level, current used 1 & 2
    #the more level is, more debug info will be printed
    #you can change this from partyline, read .uafs command help
    set debuglevel "2"
    
    ################################
    # do not edit anything below!  #
    # until u know wtf u are doing #
    ################################

    #global counter of handles.looks weird but nothing to do
    #cuz tcl returns names of arrays in undefined order,so there
    #is no way to detect last added entry.

    set handscount "0"
    
    catch {unset handles}
    array set handles {}
    
    catch {unset floodchans}
    array set floodchans {}
    
    #catch {unset usersmasks}
    #array set usersmasks {}
    catch {unset ufhstats}
    array set ufhstats {}

    catch {unset ufhignores}
    array set ufhignores {}

    array set masks {
        fullmask "1"
        nickhost "2"
        identhost "3"
        host "4"
        all "5"
        ident "6"
    }
    
    array set messages {
        "-1" "Register handle: general errror"
        "-2" "Register handle: callback function doesn't exist"
        "-3" "Register handle: floodsettings have wrong format"
        "-4" "Register handle: such hostmask type is not supported or not defined"
        "-5" "Register handle: strict mode setting format error"
        "-11" "Unregister handle: such ufh doesn't exist"
        "-21" "isflood: no such ufh exists"
        "-22" "isflood: error while creating usermask,check nick & uhost values"
        "-31" "peacetime: no such ufh exists"
        "-32" "peacetime: error while creating usermask,check nick & uhost values"
        "-41" "CreateMask: there is no such hostmask type"
        "-42" "CreateMask: uhost variable is not valid"
        "-43" "CreateMask: nick variable is not valid"
        "-51" "gethandleinfo: no such ufh exists"
        "-61" "checksoftcounter: no such ufh exists"
        "-71" "checkhardcounter: no such ufh exists"
        "-81" "reset: no such ufh exists"
    
    }
    
    set numver "000010"
    set ver "beta 10"
    set info "UAFS script for eggdrop by CoolCold <coolcold at coolcold.org>"
    set infoline "$info version $ver"

    proc putlog { text } {
        if {$text!=""} {::putlog "--- UAFS:$text"}
    }

    
    proc putdebug { dlevel text } {
        variable debugmode;variable debuglevel;variable floodchans
        if {[info level]>1} {set lvl [lindex [info level -1] 0]} else {set lvl "top-level"}        
        
        if {$text!="" && $debugmode=="1"} {
            if {$dlevel<=$debuglevel} {::putlog ".: uafs dbg|$lvl| :. $text"}
        }
    #putlog "floodchans is:[array get floodchans]"
    }

    ;#putlog "Removing our old binds ( if any ) ..."
    set tbinds [llength [binds "[namespace current]::*"]]
    foreach bind [binds "[namespace current]::*"] {
        catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
    }
    ;#putlog "$tbinds old binds removed"
    
    bind dcc m|- "uafs" ::uafs::dccstats
    bind pub n|n "!uafs" ::uafs::pubstats
    bind evnt -|- prerehash [namespace current]::deInit

}

#return values:
#>0 - UFH id
#<0 - error

proc ::uafs::registerhandle { fset {hmask "4"} {ignoreflags ""} {cback ""} { strictmode "1" } {comment "" } } {
variable handles;variable checkforcallback;variable masks
variable floodchans;variable handscount
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"
    if {$comment == ""} {set comment $lname}

    ;#[list $fset $cback $hmask $ignoreflags $strictmode]"
    set reslt "0"
    #checking mask type
    set c "0"
    foreach name [array names masks] {
        if {$masks($name)==$hmask} {incr c}
    }
    if {$c=="0"} { 
        putdebug 1 "error: such hostmask type \"$hmask\" not supported or not defined"
        return "-4"
    }
    
    #checking strict mode
    if {$strictmode!="1" && $strictmode!="0"} {
        putdebug 1 "error: strictmode value must be 0 or 1,current value is \"$strictmode\""
        return "-5"
    }
    
    set strings [lindex [split $fset :] 0]
    set secs [lindex [split $fset :] 1]
    #putlog "$fset $strings $secs [isnumber $strings] bla [isnumber $secs]"
    if {[isnumber $strings] && [isnumber $secs] && ($strings > 0) && ($secs > 0)} {
        #is callback function specified?
        #and should we check existence of callback?
        if {$cback!="" && $checkforcallback=="1"} {
            if {[info commands $cback]!=$cback} {
                putdebug 1 "error: can't find callback function \"$cback\", while script settings require existance if callback function. set checkforcallback value to \"0\" to disable this check"
                return "-2" ;#no such callback function exists
            }
        } else {
            #set piu [array size handles]
            incr handscount
            set handles($handscount) [list $fset $cback $hmask $ignoreflags $strictmode $comment]
            set floodchans($handscount) ""
            set reslt $handscount
            putdebug 1 "Handle created, id is $handscount, settings:$handles($handscount)"
        }
    } else { 
        #flood settings has got an error - not numeric values
        putdebug 1 "error: flood settings must have numeric format"
        return "-3"
    }
return $reslt
}

proc ::uafs::unregisterhandle { ufh } {
variable handles;variable floodchans;variable ufhstats;variable ufhignores
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    if {[array get handles $ufh]!=""} {
        #such ufh exists
        array unset handles $ufh
        array unset floodchans $ufh
        array unset ufhstats $ufh
        array unset ufhignores $ufh
        putdebug 1 "handle \"$ufh\" unregistered successfully"
        set reslt "1"
    } else {
        #no such ufh exists,generating error
        putldebug 1 "error: handle \"$ufh\" doesn't exists"
        set reslt "-11"
    }
return $reslt
}

proc ::uafs::isflood { ufh nick uhost {chan "all"} {ignoreflags2 ""} {check "0"} } {
variable handles;variable floodchans;variable ufhstats
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: handle \"$ufh\" doesn't exists"
        return "-21"
    }
    
    set strictmode [lindex $handles($ufh) 4]

    
    #checking for ignore flags - prevents trigger to fire on friends/owners or
    #other protected users
    set hand [nick2hand $nick]
    if {$hand!="*" && $hand!=""} {
        #user has some handle,so we can compare flags...
        set ignoreflags [lindex $handles($ufh) 3]
        if {$ignoreflags!="" || $ignoreflags2!=""} {
            #local ignore flags override global settings
            if {$ignoreflags2!=""} {
                set bla [matchattr $hand $ignoreflags2 $chan]
            } else {
                set bla [matchattr $hand $ignoreflags $chan]
            }
            if {$bla} {
                putdebug 1 "ignore flags matched,returning 0,no flood"
                addignorestats $ufh $chan
                return 0
            }
        }
    }

    set ufhmask "[string tolower [createmask $nick $uhost [lindex $handles($ufh) 2]]]"
    
    #checking if mask was created ok?
    if {[string is integer $ufhmask]} {
        #error while creating mask,looks like some params are not valid
        putdebug 1 "error: hostmask creation failed"
        return "-22"
    }


    #putdebug "checking for isflood,user mask is:$ufhmask"
    array set chans [lindex [array get floodchans $ufh] 1]
    if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
    if {[lindex [array get chans $chan] 1]!=""} {
        #this channel was added already
        array set hostmasks [lindex [array get chans $chan] 1] ;#array with history list
        set c "0"
        foreach i [array names hostmasks] {
            #putlog "$i"
            if {$i==$ufhmask} {
                #putlog "mask matching! for $i and [lindex $handles($ufh) 2]"
                incr c
                #possibly need a FIXed - should we break here?
                break
            }
        }
        if {$c=="0"} {
            #is this just softflood check not real flood check?
            if {$check==0} {
                #no mask was found
                set hostmasks($ufhmask) [list [clock seconds]]
                #putlog "hostmasks is:[array get hostmasks]"
                set chans($chan) [array get hostmasks]
                #putlog "hostmasks is:[array get hostmasks], chans is:[array get chans]"
                set floodchans($ufh) [array get chans]
                #putlog "floodchans($ufh) is $floodchans($ufh), array is [array get floodchans]"
                addstats $ufh $ufhmask $chan
            } else {
                putdebug 1 "soft or hard flood check, don't filling timestamps list"
                return 0
            }
        } else {
            #mask was found
            set histlist $hostmasks($ufhmask)
            #putlog "timestamps list length is:[llength $histlist]"
            if {[llength $histlist]<[lindex [split [lindex $handles($ufh) 0] :] 0]} {
                if {$check!=0} {putdebug 1 "soft or hard flood check, don't filling timestamps list";return 0}
                #timestamp list isn't full
                putdebug 2 "appending timestamp list for mask $ufhmask"
                lappend histlist [clock seconds]
                set hostmasks($ufhmask) $histlist
                set chans($chan) [array get hostmasks]
                set floodchans($ufh) [array get chans]
                addstats $ufh $ufhmask $chan
                #putlog "floodchans($ufh) is $floodchans($ufh), array is [array get floodchans]"
            } else {
                #timestamp list is full,let's check for flood now
                set bla [clock seconds]
                set timeshift [expr $bla - [lindex $histlist 0]]
                set histlist [lreplace $histlist 0 0]
                lappend histlist $bla
                if {$timeshift<[lindex [split [lindex $handles($ufh) 0] :] 1]} {
                    putdebug 1 "flood detected for handle \"$ufh\""
                    if {$check!=0} {putdebug 1 "soft or hard flood check, flood detected, don't filling timestamps list";return 1}
                    set reslt "1"
                    set cback [lindex $handles($ufh) 1]
                    putdebug 2 "callback func name is \"$cback\""
                    if {$cback!="" && [info commands $cback]==$cback} {
                        #calling callback function
                        putdebug 2 "calling callback..."
                        if {[catch {[$cback $ufh $nick $uhost $chan]} errdata]} {
                            putdebug 1 "error: callback function failed, here is message: $errdata"
                        }
                    }
                    if {$strictmode} {
                        set piu ""
                        foreach j $histlist {
                            #filling list with current timestamp
                            lappend piu $bla
                        }
                        set histlist $piu
                    }
                    addstats $ufh $ufhmask $chan $reslt
                } else {
                    if {$check!=0} {putdebug 1 "soft or hard flood check, ts list full,but no flood";return 0}
                    set hostmasks($ufhmask) $histlist
                    set chans($chan) [array get hostmasks]
                    set floodchans($ufh) [array get chans]
                    #putlog "floodchans($ufh) is $floodchans($ufh), array is [array get floodchans]"
                    addstats $ufh $ufhmask $chan $reslt
                }
            }
        }

    } else {
        if {$check!=0} {putdebug 1 "soft or hard flood check, don't filling timestamps list";return 0}
        #no such channel was previously added
        putdebug 2 "creating channel record for handle $ufh, channel $chan,mask $ufhmask"
        set hostmasks($ufhmask) [list [clock seconds]]
        set chans($chan) [array get hostmasks]
        #putlog "hostmasks is:[array get hostmasks], chans is:[array get chans]"
        set floodchans($ufh) [array get chans]
        #putlog "floodchans($ufh) is $floodchans($ufh), array is [array get floodchans]"
        addstats $ufh $ufhmask $chan

    }
return $reslt
}

proc ::uafs::peacetime { ufh nick uhost {chan "all"} } {
variable handles;variable floodchans
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: no such handler \"$ufh\" exists"
        return "-31"
    }
    set ufhmask "[string tolower [createmask $nick $uhost [lindex $handles($ufh) 2]]]"
    
    #checking if mask was created ok?
    if {[string is integer $ufhmask]} {
        #error while creating mask,looks like some params are not valid
        putdebug 1 "error: hostmask creation failed"
        return "-32"
    }
    
    #putdebug 2 "checking for isflood,user mask is:$ufhmask"
    array set chans [lindex [array get floodchans $ufh] 1]
    if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
    if {[lindex [array get chans $chan] 1]!=""} {
        #this channel was added already
        array set hostmasks [lindex [array get chans $chan] 1] ;#array with history list
        set c "0"
        foreach i [array names hostmasks] {
            #putlog "$i"
            if {$i==$ufhmask} {
                #putlog "mask matching! for $i and [lindex $handles($ufh) 2]"
                incr c
                #possibly need a FIXed - should we break here?
                break
            }
        }
        if {$c=="0"} {
            #no mask was found,so user may say smth immediately
            #result should be set to 0
            return 0
        } else {
            #let's check is timestamps list is full or not
            set histlist $hostmasks($ufhmask)

            if {[llength $histlist]<[lindex [split [lindex $handles($ufh) 0] :] 0]} {
                #timestamps list isn't full,so user has right to flood a bit
                return 0
            }
            #mask was found,let's get first value
            
            if {[lindex $histlist 0]==""}  {
                #no timestamps were added,user may say smth immediately
                return 0
            }
            set bla [clock seconds]
            set timeshift [expr $bla - [lindex $histlist 0]]
            #putlog "timeshift is:$timeshift"
            #putlog "1st record and current time difference is:[expr [lindex [split [lindex $handles($ufh) 0] :] 1] - $timeshift]"
            if {$timeshift<=[lindex [split [lindex $handles($ufh) 0] :] 1]} {
                #user exceeded msg limits and maybe overceeded it
                set reslt "1"
                set piu [expr [lindex [split [lindex $handles($ufh) 0] :] 1] - $timeshift]
                if {$piu!="0"} {set reslt $piu}
                putdebug 2 "peace time is:$piu,timeshift is $timeshift"
            }
        }
    } else {
        #no such channel was previously added
        #so user may say smth immediately.
        #result should be set to 0
    }

return $reslt
}

proc ::uafs::createmask { nick uhost masktype } {
variable masks
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"
    #checking for right form of uhost
    set bla [string first "@" $uhost]
    if {[string length $uhost]<3 || $bla=="-1" ||\
        $bla==[expr [string length $uhost] - 1] || $bla=="1"  } {
        putdebug 1 "error: uhost variable is not valid"
        return "-42"
    }
    #checking for right form of nick
    if {[string length $nick]<1} {
        putdebug 1 "error: nick variable is not valid"
        return "-43"
    }
    
    #checking masktype value
    switch -exact -- $masktype\
    $masks(fullmask) {
        putdebug 2 "masktype is fullmask"
        set reslt "$nick!$uhost"
    }\
    $masks(nickhost) {
        putdebug 2 "masktype is nickhost"
        set reslt "$nick!*[string range $uhost $bla end]"
    }\
    $masks(identhost) {
        putdebug 2 "masktype is identhost"
        set reslt "*!$uhost"
    }\
    $masks(host) {
        putdebug 2 "masktype is host"
        set reslt "*!*[string range $uhost $bla end]"
    }\
    $masks(all) {
        putdebug 2 "masktype is all"
        set reslt "*!*@*"
    }\
    $masks(ident) {
        putdebug 2 "masktype is ident"
        set identval [string range $uhost 0 [expr $bla - 1]]
        set reslt "*!$identval@*"
    }\
    default {
        putdebug 1 "error: no such mask type \"$masktype\" exists"
        return "-41"
    }
    putdebug 2 "return value:$reslt"
return $reslt
}

proc ::uafs::formatmessage { id } {
variable messages
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    if {[array get messages $id]==""} {
        #there is no message for such error code
        putdebug 1 "error: there is no such error code \"$id\" defined"
        set reslt "there is no message for such error code"
    } else {
        set reslt "$messages($id)"
    }
    putdebug 2 "return value:$reslt"
return $reslt
}

proc ::uafs::gethandleinfo { ufh {type ""}} {
variable handles
;#variable floodchans
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"
    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: no such ufh handle \"$ufh\" exists"
        return "-51"
    }
    switch -exact -- $type\
    "fset" {
        set reslt [lindex $handles($ufh) 0]
    }\
    "callback" {
        set reslt [lindex $handles($ufh) 1]
    }\
    "hostmask" {
        set reslt [lindex $handles($ufh) 2]
    }\
    "ignoreflags" {
        set reslt [lindex $handles($ufh) 3]
    }\
    "strictmode" {
        set reslt [lindex $handles($ufh) 4]
    }\
    "comment" {
        set reslt [lindex $handles($ufh) 5]
    }\
    "all" -\
    default {
        set reslt $handles($ufh)
    }
    putdebug 2 "return value:$reslt"
return $reslt
}

proc ::uafs::addstats { ufh ufhmask chan {isflood "0"}} {
variable ufhstats

#me has got idea to add counters of "soft" & "hard" flood
#let's realize this sh.t ;)

#description:
#"soft" flood counter - this is counter of flood events with incrementation
#but if isflood returns 0, this counter resets to 0 again.
#so this is "flood combo" - series of flood events untill
#isflood returns false.

#This is useful, for example if you want to protect bot from being slapped,
#so you want to warn somebody after 2 slaps in 1 minute,
#and if user ignores warning, kick them, and if kick doesn't correct users'
#mind ban him. Here we can see "flood combo" - if flood detected 1st time -
#warn, 2nd time - kick, 3rd time ban. But if user reduced his "slaps rate"
#and waited for example 1 minute after warning, so his "penalty points"
#will be resetted and user may have 2nd chance to be banned ;)
#But note, strict mode setting also has influence on script's behavior,
#read readme.htm to get more info.


#"hard" flood counter - this is counter of total flood events,
#it doesn't reset if isflood returns 0, so you are able to know
#how much times this mask generated flood event on this channel with
#this handle.
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    if { ![string match "[namespace current]*" $lname] } {
        putdebug 1 "function was called from incorrect place, ignoring"
        return 1
    }


    array set chans [lindex [array get ufhstats $ufh] 1]
    if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
    if {[lindex [array get chans $chan] 1]!=""} {
        #such channel already exists,extracting hostmask data
        putdebug 2 "channel $chan exists in database!"
        array set hostmasks $chans($chan)
        putdebug 2 "hostmasks array is:[array get hostmasks]"
        putdebug 2 "array names are:[array names hostmasks *]"
        #checking if hostmask ufhmask already added
        if {[lsearch -exact [array names hostmasks *] $ufhmask]!=-1} {
            #such element found in statistics
            #putdebug 2 "hello,we found data for ufhmask $ufhmask in ufhstats \"[array get ufhstats]\""
            set fired [lindex $hostmasks($ufhmask) 0]           
            set flooded [lindex $hostmasks($ufhmask) 1]
            set softflood [lindex $hostmasks($ufhmask) 2]
            set hardflood [lindex $hostmasks($ufhmask) 3]
            if {$fired==""} {set fired "0"}
            if {$flooded==""} {set flooded "0"}
            if {$softflood==""} {set softflood "0"}
            if {$hardflood==""} {set hardflood "0"}
            if {$isflood=="0"} {incr fired;set softflood "0"} else {incr fired;incr flooded;incr softflood;incr hardflood}
            set hostmasks($ufhmask) [list $fired $flooded $softflood $hardflood]
            putdebug 2 "new fired values:$hostmasks($ufhmask)"
        } else {
            #no such element in hostmasks array,let's add it
            #putdebug 2 "hello,no data for $ufhmask in \"[array get ufhstats]\""
            set hostmasks($ufhmask) [list 1 0 0 0]
        }
        set chans($chan) [array get hostmasks]

    } else {
        #there is no such channel
        putdebug 2 "hello,adding channel record \"$chan\" ...keke,me wanna sleep - 1:51 AM already..."
        set hostmasks($ufhmask) [list 1 0 0 0]
        set chans($chan) [array get hostmasks]
    }
    set ufhstats($ufh) [array get chans]
    
    putdebug 2 "value is: $ufhstats($ufh)"
}

proc ::uafs::addignorestats { ufh chan } {
variable ufhstats;variable ufhignores

    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    if { ![string match "[namespace current]*" $lname] } {
        putdebug 1 "function was called from incorrect place, ignoring"
        return 1
    }

    array set chans [lindex [array get ufhignores $ufh] 1]
    if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
    if {[lindex [array get chans $chan] 1]!=""} {
        #such channel already exists,extracting hostmask data
        putdebug 2 "channel $chan exists in database!"
        incr chans($chan)
    } else {
        #there is no such channel
        putdebug 2 "adding channel record \"$chan\""
        set chans($chan) 1
    }
    set ufhignores($ufh) [array get chans]
    
    putdebug 2 "value is: $ufhignores($ufh)"
}


proc ::uafs::dccstats { handle idx text } {
global lastbind
variable ufhstats;variable handles;variable floodchans;variable ufhignores
variable debugmode;variable debuglevel
#this proc will display uafs related data & statistics
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    set rest [string tolower [lindex [split $text ] 0]]
    set statsmode [string tolower [lindex [split $text ] 1]]
    set param3 [string tolower [lindex [split $text ] 2]]
    set param4 [string tolower [lindex [split $text ] 3]]
    switch -exact -- $rest\
    "stats" {
        switch -exact -- $statsmode {
            "channels" {
                putdebug 2 "requesting channels stats"
                putdcc $idx "Listing all channels stored in uafs database"
                #Done: add view of #channel | ufh1 ufh2....all ufhs
                if {[array names ufhstats]!=""} {
                    set allchans ""
                    putdcc $idx "Handle id | Channels"
                    foreach i [array names ufhstats] {
                        array set chans $ufhstats($i)
                        putdcc $idx "$i[string repeat " " [expr {10 - [string length "$i"]}]]| [array names chans]"
                        #collecting data in format #chan | handle1 handle2 ...
                        set allchans [concat $allchans [array names chans]]
                    }
                    set allchans [lsort -unique $allchans]
                    foreach i $allchans {
                        #searching for channel
                        foreach j [array names ufhstats] {
                            array set chans $ufhstats($j)
                            if {[lsearch -exact [array names chans] $i]!="-1"} {
                                lappend ufhs($i) $j
                            }
                        }
                    }
                    putdcc $idx "Channels                 | Handles ids"
                    foreach i [array names ufhs] {
                        #this possible need a FIX - if channels exceed 25 characters long, this will fail.
                        putdcc $idx "$i[string repeat " " [expr {25 - [string length "$i"]}]]| [join $ufhs($i) " "]"
                    }
                    
                } else {
                    if {[array names handles]==""} {
                        ;#there are no registered handles yet
                        putdcc $idx "no uafs handles were registered"
                    } else {
                        ;#some handle exists, but there is no stats
                        putdcc $idx "one or more handles exists, but there is no stats about usage, may be flood check was never called"
                        putdcc $idx "use \".$lastbind $rest handles\" to obtain info about used handles"
                    }
                }
            }
            "handles" {
                putdebug 2 "requesting handles stats"
                if {[array names handles]!=""} {
                    putdcc $idx "uafs handles' ids in use: [array names handles]"
                    putdcc $idx "uafs total handles in use: [llength [array names handles]]"
                } else {
                    putdcc $idx "no uafs handles were registered"
                }
            }
            "handle" {
                putdebug 2 "requesting handle \"$param3\" stats"
                if {$param3==""} {putdcc $idx "please specify handle id";return 1}
                set hinfo [gethandleinfo $param3]
                if {!([string is integer $hinfo] && $hinfo < 0)} {
                    putdcc $idx "Info about handle \"$param3\""
                    putdcc $idx "Flood settings:[lindex $hinfo 0], hostmask type:[lindex $hinfo 2], ignore flags:[lindex $hinfo 3], callback function:[lindex $hinfo 1], strict mode:[lindex $hinfo 4], comment:[lindex $hinfo 5]"
                    #getting stattttz
                    if {[array get ufhstats $param3]!=""} {
                        #chans array filled for this handle
                        array set chans $ufhstats($param3)
                        set handlechans [array names chans]
                        putdcc $idx "Channels used on:[join $handlechans ,]"
                        putdcc $idx "\#chan (total masks/ignores) | masks ( checks/floods/soft/hard )"
                        foreach i [array names chans] {
                            array set hmasks $chans($i)
                            set datastring ""
                            foreach j [array names hmasks] {
                                #putlog "j is $j"
                                append datastring "$j ([join $hmasks($j) "/"]) "
                            }
                            #getting ignores statistics
                            array set ignorechans [lindex [array get ufhignores $param3] 1]
                            if {[lindex [array get ignorechans [string tolower $i]] 1]!=""} {
                                set ignores $ignorechans([string tolower $i])
                            } else {
                                set ignores 0
                            }
                            putdcc $idx "$i ([llength [array names hmasks]]/$ignores) | $datastring"
                        }
                    } else {
                        putdcc $idx "Channels: empty ( handle exists but was not used )"
                        putdcc $idx "Masks: empty (handle exists but was not used )"
                    
                    }
                    
                } else {
                    putdcc $idx "no such handle \"$param3\" exists, use \".$lastbind stats handles\" to obtain list of existen handles"
                }
            }
            "size" {
                putdcc $idx "events data:[string bytelength [array get floodchans]], stats data:[string bytelength [array get ufhstats]]"
            }
            "help" -
            default {
                #help nax
                putdcc $idx "UAFS statistics help section - available commands:"
                putdcc $idx ".$lastbind $rest channels - lists all channels stored in uafs database"
                putdcc $idx ".$lastbind $rest handles - shows all handles & total count"
                putdcc $idx ".$lastbind $rest handle <id> - shows info and statistics about handle <id>"
                putdcc $idx ".$lastbind $rest size - shows memory usage used by uafs structures"
            }
        }
    }\
    "debug" {
        if {$statsmode=="on"} {
            set debugmode 1
            putdebug 2 "enabling debug output"
            putdcc $idx "debug mode enabled"
        } elseif {$statsmode==""} {
            putdcc $idx "please specify on or off"
        } else {
            putdebug 2 "disabling debug output"
            set debugmode 0
            putdcc $idx "debug mode disabled"
        }
    }\
    "dlevel" {
        if {[isnumber $statsmode]==1} {
            putdebug 2 "setting debuglevel into:\"$statsmode\""
            set debuglevel $statsmode
            putdcc $idx "debug level is set into:\"$statsmode\""
        } else {
            putdebug 2 "debug level is not numeric ($statsmode), failed"
            putdcc $idx "debuglevel should be numeric value"
        }
    }\
    "chandle" {
        ;#changing handle attributes ( flood settings now )
        ;#format: chandle <hid> <fset> <param>
        putdebug 1 "modifying handle \"$statsmode\" data"
        if {$statsmode==""} {putdcc $idx "please specify handle id";return 1}
        set hinfo [gethandleinfo $statsmode]
        if {([string is integer $hinfo] && $hinfo < 0)} {
            putdcc $idx "no such handle \"$statsmode\" exists, use \".$lastbind stats handles\" to obtain list of existen handles"
            return 1
        }
        
        switch -exact -- $param3 {
            "fset" {
                set fset $param4
                set strings [lindex [split $fset :] 0]
                set secs [lindex [split $fset :] 1]
                #putlog "$fset $strings $secs [isnumber $strings] bla [isnumber $secs]"
                if {[isnumber $strings] && [isnumber $secs] && ($strings > 0) && ($secs > 0) } {
                    putdebug 2 "looks like fset is in numeric format. requested $param4, current [lindex $hinfo 0]"
                    ;#now let's modify history (timestamp) list
                    ;#we need to check all hostmasks for all chans and trunctate histlist if needed
                    if {$param4==[lindex $hinfo 0]} {
                        ;#new and old are the same
                        putdebug 2 "modify cancelled - old and new value for \"fset\" are the same"
                        putdcc $idx "modify cancelled - old and new value for \"fset\" are the same"
                    } elseif { $strings < [lindex [split [lindex $hinfo 0] :] 0]} {
                        putdebug 2 "we have to trunctate list"
                        array set chans [lindex [array get floodchans $statsmode] 1]
                        foreach i [array names chans] {
                            array set hostmasks [lindex [array get chans $i] 1] ;#array with history list
                            foreach j [array names hostmasks] {
                                putdebug 2 "histlist is $hostmasks($j),$j,$i"
                                set hostmasks($j) [lrange $hostmasks($j) end-[expr $strings-1] end]
                            }
                            set chans($i) [array get hostmasks]
                        }
                        set floodchans($statsmode) [array get chans]
                        set handles($statsmode) [lreplace $handles($statsmode) 0 0 $fset]
                    } else {
                        putdebug 2 "we have to enlarge list, but no actions should be really taken cuz isflood will enlarge list automaticly"
                        set handles($statsmode) [lreplace $handles($statsmode) 0 0 $fset]
                    }
                } else {
                    putdebug 2 "fset is \"$fset\" and not numeric or some of values is equal to 0, ignoring"
                    putdcc $idx "flood settings are not in numeric format, use correct format, \"3:10\" for example"
                }
            }
            default {
                putdcc $idx "unknown type \"$param3\", use \".$lastbind help\" for listing all supported types"
            }
        }
    }\
    "help" -\
    default {
        putdcc $idx "UAFS help section - available commands:"
        putdcc $idx ".$lastbind stats - provides commands to view uafs usage statistics"
        putdcc $idx ".$lastbind debug \[on\]/\[off\] - to enable/disable debug, current is \[$debugmode\]"
        putdcc $idx ".$lastbind dlevel <value> - sets debug level value, supported 1 and 2, now level is \[$debuglevel\]"
        putdcc $idx ".$lastbind chandle <ufh> <type> <value(s)> - sets different handle related settings"
        putdcc $idx "    -- now supported types are:"
        putdcc $idx "       \"fset\" - changing flood limits for handle <ufh>"
    }
return 1
}

proc ::uafs::checksoftcounter { ufh nick uhost {chan "all"} } {
#this proc will return "softflood" counts
variable ufhstats;variable handles;variable floodchans
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"
    
    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: no such ufh handle \"$ufh\" exists"
        return "-61"
    }
    set hmask [gethandleinfo $ufh "hostmask"]
    if {!([string is integer $hmask] && $hmask < 0)} {
        #mask info is ok
        set ufhmask [string tolower [createmask $nick $uhost $hmask]]
        if {![string is integer $ufhmask]} {
            #mask was created ok
            set flooded [isflood $ufh $nick $uhost $chan "" "1"]
            putdebug 2 "flood check returned $flooded"
            if {$flooded==0} {
                ;#here we need to return 0 for soft flood
                ;#cuz in current moment user isn't listed as flooder
                return 0
            } elseif { $flooded==1 } {
                ;#now let's check if user listed in stats.
                putdebug 2 "bot tells it is flooded, checking soft-floods list"
                
                array set chans [lindex [array get ufhstats $ufh] 1]
                if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
                if {[lindex [array get chans $chan] 1]!=""} {
                    #such channel already exists,extracting hostmask data
                    array set hostmasks $chans($chan)
                    #checking if hostmask ufhmask already added
                    if {[lsearch -exact [array names hostmasks *] $ufhmask]!=-1} {
                        #such element found in statistics
                        putdebug 2 "hello,we found data for ufhmask $ufhmask in ufhstats \"[array get ufhstats]\""
                        set softflood [lindex $hostmasks($ufhmask) 2]
                        putdebug 2 "returning $softflood"
                        return $softflood
                    } else {
                        #no such element in hostmasks array,let's add it
                        putdebug 2 "hello,no data for $ufhmask in \"[array get ufhstats]\""
                        return 0

                    }

                } else {
                    #there is no such channel
                    putdebug 1 "hello,adding channel record \"$chan\" ...keke,me wanna sleep - 1:51 AM already..."
                    return 0
                }
                putdebug 2 "value is: $ufhstats($ufh)"
            
            } else {
                ;#some error occured
                putdebug 1 "some error occured, code is \"$flooded\", message is:[formatmessage $flooded]"
                putlog "[formatmessage $flooded]"

            }
        } else {
            putdebug 1 "error: can't create hostmask"
            return "$ufhmask"
        }
    } else {
        putdebug 1 "error: can't get hostmask type"
        return "$hmask"
    }

}

proc ::uafs::checkhardcounter { ufh nick uhost {chan "all"} } {
#this proc will return "hardflood" counts
variable ufhstats;variable handles;variable floodchans
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"
    
    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: no such ufh handle \"$ufh\" exists"
        return "-71"
    }
    set hmask [gethandleinfo $ufh "hostmask"]
    if {!([string is integer $hmask] && $hmask < 0)} {
        #mask info is ok
        set ufhmask [string tolower [createmask $nick $uhost $hmask]]
        if {![string is integer $ufhmask]} {
            #mask was created ok
            set flooded [isflood $ufh $nick $uhost $chan "" "1"]
            putdebug 2 "flood check returned $flooded"
            if {$flooded==0} {
                ;#here we need to return 0 for hard flood
                ;#cuz in current moment user isn't listed as flooder
                return 0
            } elseif { $flooded==1 } {
                ;#now let's check if user listed in stats.
                putdebug 2 "bot tells it is flooded, checking hard-floods list"
                
                array set chans [lindex [array get ufhstats $ufh] 1]
                if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}
                if {[lindex [array get chans $chan] 1]!=""} {
                    #such channel already exists,extracting hostmask data
                    array set hostmasks $chans($chan)
                    #checking if hostmask ufhmask already added
                    if {[lsearch -exact [array names hostmasks *] $ufhmask]!=-1} {
                        #such element found in statistics
                        putdebug 2 "hello,we found data for ufhmask $ufhmask in ufhstats \"[array get ufhstats]\""
                        set softflood [lindex $hostmasks($ufhmask) 3]
                        return $softflood
                    } else {
                        #no such element in hostmasks array,let's add it
                        putdebug 2 "hello,no data for $ufhmask in \"[array get ufhstats]\""
                        return 0
                    }
                } else {
                    #there is no such channel
                    putdebug 1 "hello,adding channel record \"$chan\" ...keke,me wanna sleep - 1:51 AM already..."
                    return 0
                }
                putdebug 2 "value is: $ufhstats($ufh)"
            
            } else {
                ;#some error occured
                putdebug 1 "some error occured, code is \"$flooded\", message is:[formatmessage $flooded]"
                putlog "[formatmessage $flooded]"

            }
        } else {
            putdebug 1 "error: can't create hostmask"
            return "$ufhmask"
        }
    } else {
        putdebug 1 "error: can't get hostmask type"
        return "$hmask"
    }
}

;#!uafs  - reports for #chan : total requests, ignored requests, masks count...
proc ::uafs::pubstats { nick uhost hand chan rest } {
variable ufhstats;variable handles;variable ufhignores

    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    ;#we should get all handles data recursivly
    set chanorig $chan
    set chan [string tolower $chan]
    set ufhs [array names handles]
    if {$ufhs!=""} {
        set currchan(tmasks) 0
        set currchan(tchecks) 0
        set currchan(tfloods) 0
        set currchan(ignores) 0
        set currchan(triggers) ""

        set globchan(tmasks) 0
        set globchan(tchecks) 0
        set globchan(tfloods) 0
        set globchan(ignores) 0
        set globchan(triggers) ""

        foreach i $ufhs {
            putdebug 2 "processing handle $i"
            set trigged 0
            if {[lindex [array get ufhignores $i]]!=""} {
                ;#there are records for such handle
                putdebug 2 "ufhignores contain record for handle $i ( ignores )"
                array set ignorechans $ufhignores($i)
                foreach k [array names ignorechans] {
                    if {([string tolower $k] == $chan) && [lindex [array get ignorechans $chan] 1]!=""} {
                        putdebug 2 "processing current channel ( $chan )"
                        set trigged 1
                        set currchan(ignores) [expr $currchan(ignores) + $ignorechans($chan)]
                        set globchan(ignores) [expr $globchan(ignores) + $ignorechans($chan)]
                    } else {
                        ;#here will be global counters
                        putdebug 2 "processing global channel $k"
                        set globchan(ignores) [expr $globchan(ignores) + $ignorechans($k)]
                    }
                }

            }
            catch {unset chans};array set chans {}
            if {[lindex [array get ufhstats $i] 1]!=""} {
                putdebug 2 "$i is in ufhstats"
                array set chans $ufhstats($i)
                

                foreach l [array names chans] {
                    putdebug 2 "processing channel $l (fired stats)"
                    
                    array set hostmasks $chans($l)
                    set hmasknames [array names hostmasks]
                    
                    if {([string tolower $l] == $chan ) && [lindex [array get chans $chan] 1]!=""} {
                        ;#getting stats for current channel
                        putdebug 2 "getting stats for current channel $chan from ufhstats"
                        set currchan(tmasks) [expr $currchan(tmasks) + [llength $hmasknames]]
                        set globchan(tmasks) [expr $globchan(tmasks) + [llength $hmasknames]]
                        set trigged 1
                        foreach j $hmasknames {
                            set fired [lindex $hostmasks($j) 0]           
                            set flooded [lindex $hostmasks($j) 1]
                            set currchan(tchecks) [expr $currchan(tchecks) + $fired]
                            set currchan(tfloods) [expr $currchan(tfloods) + $flooded]
                            set globchan(tchecks) [expr $globchan(tchecks) + $fired]
                            set globchan(tfloods) [expr $globchan(tfloods) + $flooded]
                        }
                    } else {
                        ;#here will be global counters
                        putdebug 2 "getting stats for global channel $l from ufhstats"
                        set globchan(tmasks) [expr $globchan(tmasks) + [llength $hmasknames]]
                        foreach j $hmasknames {
                            set fired [lindex $hostmasks($j) 0]           
                            set flooded [lindex $hostmasks($j) 1]
                            set globchan(tchecks) [expr $globchan(tchecks) + $fired]
                            set globchan(tfloods) [expr $globchan(tfloods) + $flooded]
                        }
                    }
                }
            }

            
            if {$trigged} {
                set hmask [gethandleinfo $i "comment"]
                if {!([string is integer $hmask] && $hmask < 0)} {
                    putdebug 2 "appending trigger \"$hmask\" into triggers list"
                    set tmp1 $currchan(triggers)
                    lappend tmp1 $hmask
                    set currchan(triggers) $tmp1
                    catch {unset tmp1}
                }
                
            }
        }
        putserv "NOTICE $nick : UAFS stats for channel $chan: $currchan(tchecks) flood check(s), $currchan(tfloods) flood(s), $currchan(ignores) check(s) ignored, $currchan(tmasks) masks. Used binds:\[[join $currchan(triggers) ,]\]"
        putserv "NOTICE $nick : UAFS global stats: $globchan(tchecks) flood check(s), $globchan(tfloods) flood(s), $globchan(ignores) check(s) ignored, $globchan(tmasks) masks"
    } else {
        putserv "NOTICE $nick : UAFS stats: no registered handles"
    }


}

;#::uafs::reset - resets timestamps for selected ufh(mask)
proc ::uafs::reset {ufh nick uhost {chan "all"} } {
variable ufhstats;variable handles;variable floodchans
    putdebug 2 "function called with params: [lrange [info level 0] 1 end]"
    if {[info level]>1} {set lname [lindex [info level -1] 0]} else {set lname "top-level"}
    putdebug 2 "function called from: $lname"

    set reslt "0"
    if {[array get handles $ufh]==""} {
        #no such ufh handler exists
        putdebug 1 "error: no such handler \"$ufh\" exists"
        return "-81"
    }
    
    
    if {$nick!=""} {
    	set ufhmask "[string tolower [createmask $nick $uhost [lindex $handles($ufh) 2]]]"
        
        #checking if mask was created ok?
        if {[string is integer $ufhmask]} {
            #error while creating mask,looks like some params are not valid
            putdebug 1 "error: hostmask creation failed"
            return "$ufhmask"
        }
    
    } else {
    	;#if nick is empty, we should reset all ufh data...	
    	putdebug 1 "clearing ALL history lists for handle \"$ufh\""
    	set floodchans($ufh) ""
    	return 0
    }
    
    #putdebug "checking for isflood,user mask is:$ufhmask"
    array set chans [lindex [array get floodchans $ufh] 1]
    if {$chan==""} {set chan "all"} else {set chan [string tolower $chan]}

    array set hostmasks [lindex [array get chans $chan] 1]
    if {[lindex [array get chans $chan] 1]!=""} {
        #this channel was added already
        array set hostmasks [lindex [array get chans $chan] 1] ;#array with history list
        set c "0"
        foreach i [array names hostmasks] {
            #putlog "$i"
            if {$i==$ufhmask} {
                #putlog "mask matching! for $i and [lindex $handles($ufh) 2]"
                incr c
                #possibly need a FIXed - should we break here?
                break
            }
        }
        if {$c!="0"} {
            #mask was found
            putdebug 1 "clearing history list for handle \"$ufh\", mask \"$ufhmask\""
            set hostmasks($ufhmask) ""
		}
	}

	;#repacking here
    set chans($chan) [array get hostmasks]
    set floodchans($ufh) [array get chans]
	return 0

}

proc ::uafs::deInit {args} {
    catch {unbind evnt -|- prerehash [namespace current]::deInit}
    #removing our binds
    #putlog "Removing our old binds ( if any ) ..."
    set tbinds [llength [binds "[namespace current]::*"]]
    foreach bind [binds "[namespace current]::*"] {
        catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
    }
    #putlog "$tbinds old binds removed"

    namespace delete [namespace current]
}

#this functions is part of alltools.tcl
proc ::uafs::isnumber {string} {
  if {([string compare "" $string]) && \
      (![regexp \[^0-9\] $string])} then {
    return 1
  }
  return 0
}

putlog "TCL LOADED:$::uafs::infoline"
